local db
TUSUI = {}

TUSUISplash = CreateFrame("Frame", "TUSUI_Customs", UIParent)
TUSUISplash:RegisterEvent("ADDON_LOADED")
TUSUISplash:RegisterEvent("PLAYER_LOGIN")

local Addon = "TUSUI_Customs"
local function Meta(vaL)
	local text = GetAddOnMetadata(Addon, vaL)
	return text
end

local function dialog(value)
	StaticPopup_Hide("First Run of TUSUI")
	StaticPopup_Hide("TUSUI_HELP1")
	StaticPopup_Hide("TUSUI_HELP2")
	StaticPopup_Hide("REFLUX")
	StaticPopup_Hide("POWERAURAS")
	StaticPopup_Hide("FORTE")	
	StaticPopup_Hide("DOMINOS")
	StaticPopup_Show(value)
end

local function Install()
	if IsAddOnLoaded("Reflux") then
		db.installed = true
		SlashCmdList["REFLUX"]("switch UltimateShamanUI")
	else
		print(Meta("title")..": Reflux was found to be disabled, please enable the addon and retry the install with the slash command '/tusui install'.")
	end
end

StaticPopupDialogs["TUSUI_HELP1"] = {
	text = Meta("TITLE").." Help Dialog 1:\nWhat do you need help with?", 
	button1 = "Reflux doesn't work",
	button2 = "Power Auras",
	button3 = "Something else.",
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1,
	sound = "",
	OnAccept = function() dialog("REFLUX") end,
	OnAlt = function() dialog("TUSUI_HELP2") end,
	OnCancel = function() dialog("POWERAURAS") end,
}

local function Understood()
	print(Meta("Title")..": If you have any questions or suggestions, feel free to leave a post or pm on the WoWinterface download page, or email me to shamtasticle@gmail.com");
	print(Meta("title")..": Remember you can always use '/tusui help or help2' to bring up the help dialogs.")
	db.first = false
end

local function MoreHelp()
	dialog("TUSUI_HELP1")		
end

StaticPopupDialogs["TUSUI_HELP2"] = {
	text = Meta("TITLE").." Help Dialog 2:\nWhat do you need help with?",
	button1 = "ForteXorcist\n(Cooldown bar)",
	button2 = "Dominos\n(Action Bars)",
	button3 = "More help!",
	timeout = 0,
	whiledead = 1,
	hideOnEscape = 1,
	sound = "",
	OnAccept = function() dialog("FORTE") end,
	OnCancel = function() dialog("DOMINOS") end,
	OnAlt = function() MoreHelp() end,
}

StaticPopupDialogs["REFLUX"] = {
	text = "The command used for the reflux switch is as follows and is CASE SENSITIVE:\n '/reflux switch UltimateShamanUI'\n\nYou may also save any changes you've made to the reflux profile with: '/reflux save'.\n Should this not work double check that reflux is turned on and you've copied your variables correctly.",
	button1 = "I understand",
	button2 = "More help!",
	timeout = 0,
	whiledead = 1,
	hideOnEscape = 1,
	sound = "",
	OnAccept = function() Understood() end,
	OnCancel = function() MoreHelp() end,
}

StaticPopupDialogs["POWERAURAS"] = {
	text = "To bring up options for PAC, type '/powa'\n\nShift clicking an aura will turn it off.\n You may also allow an aura to show per spec by unchecking the spec you don't want it to show on, keep in mind that the 'Any' checkbox is not for spec assignment.",
	button1 = "I understand",
	button2 = "More help!",
	timeout = 0,
	whiledead = 1,
	hideOnEscape = 1,
	sound = "",
	OnAccept = function() Understood() end,
	OnCancel = function() MoreHelp() end,
}

StaticPopupDialogs["FORTE"] = {
	text = "To bring up options for forte use '/fx'\n\nClick on a module you'd like to move or edit on the bottom.\n\nTo move a module, click on the padlock at the top left to lock or unlock.",
	button1 = "I understand",
	button2 = "More help!",
	timeout = 0,
	whiledead = 1,
	hideOnEscape = 1,
	sound = "",
	OnAccept = function() Understood() end,
	OnCancel = function() MoreHelp() end,
}

StaticPopupDialogs["DOMINOS"] = {
	text = "To bring up options for dominos, type '/dom'\n\n Clicking on configure bars will allow you to move them and edit class specific functions.\n\n'Bind Keys' allows you to mouseover an action button and asign a keybind.",
	button1 = "I understand",
	button2 = "More help!",
	timeout = 0,
	whiledead = 1,
	hideOnEscape = 1,
	sound = "",
	OnAccept = function() Understood() end,
	OnCancel = function() MoreHelp() end,
}

TUSUISplash:SetScript("OnEvent", function(self,event,...)	
	local arg1, arg2 = ...
	if event == "ADDON_LOADED" and arg1 == "TUSUI_Customs" then
		if not TUSUIDB or (not TUSUIDB.version) or (TUSUIDB.version < tonumber(Meta("version"))) then 
			TUSUIDB = { 
				first = true,
				splash = true,
				hideRaid = true,
				version = tonumber(Meta("version")),
				classcolor = true
			}
		end
		
		db = TUSUIDB
		
		-- Update Frame Positions
				
		-- Create Logo Splash
		
		self:Hide()
		self:SetWidth(400)
		self:SetHeight(100)
		self:SetPoint("CENTER", UIParent, "CENTER")
		self.LogoBG = self:CreateTexture(nil, "MEDIUM")
		self.LogoBG:SetAllPoints(self)
		self.LogoBG:SetTexture("Interface\\AddOns\\TUSUI_Customs\\images\\logo")
		local color = RAID_CLASS_COLORS[select(2,UnitClass("player"))]
		self.LogoBG:SetVertexColor(color.r,color.g,color.b)
		self.LogoText = self:CreateTexture(nil, "OVERLAY")
		self.LogoText:SetAllPoints(self)
		self.LogoText:SetTexture("Interface\\AddOns\\TUSUI_Customs\\images\\logo_"..select(2, UnitClass("player")))
		
		local fadeIn = {}
		fadeIn.mode = "IN"
		fadeIn.timeToFade = 2
		fadeIn.startAlpha = 0
		fadeIn.endAlpha = 1
		
		local fadeOut = {}
		fadeOut.mode = "OUT"
		fadeOut.timeToFade = 2
		fadeOut.startAlpha = 1
		fadeOut.endAlpha = 0
		
		fadeOut.finishedFunc = function()
			if not db.installed then
				--db.first = false
				StaticPopupDialogs["Install Dialog"] = {
				text = "Welcome to "..Meta("Title").."\n\nPlease click the 'Install' button to get started.", 
				button1 = "Install",
				button2 = "Ignore",
				timeout = 0,
				whileDead = 0, 
				hideOnEscape = 0,
				sound = "",
				OnAccept = function() Install() end,
				OnCancel = function() Understood(); db.installed = true end,
				}
				StaticPopup_Show("Install Dialog")				
			elseif db.installed then
				if db.first then
					StaticPopupDialogs["First Run of TUSUI"] = {
						text = "Welcome to "..Meta("Title").."\nOn your first run of the UI you may be unsure of a few addons. If you're confident you're familiar with the addons in this package, click 'I understand'.", 
						button1 = "I understand.",				
						button2 = "Help me!",
						timeout = 0,
						whileDead = 1, 
						hideOnEscape = 1,
						sound = "",
						OnAccept = function() Understood() end,
						OnAlt = function() MoreHelp() end,
						OnCancel = function() MoreHelp() end,
					}
					StaticPopup_Show("First Run of TUSUI")	
				end
			end
		end
		fadeIn.finishedFunc = function ()
			local f = CreateFrame("Frame")
				f.timer = 0
				f:SetScript("OnUpdate", function(self, elapsed)
				f.timer = f.timer + elapsed
				if f.timer > 4 then
					UIFrameFade(TUSUISplash, fadeOut)
					f:SetScript("OnUpdate", nil)
				end				
			end)
		end
		
		function self:Splash()
			UIFrameFade(TUSUISplash, fadeIn)
		end
		
	elseif event == "PLAYER_LOGIN" then		
		if db.splash then
			self:Splash()
		end		
	end	
end)

local info = {};
info.splash = function()
	if db.splash then
		print(Meta("title").." Splash now disabled on login.")
	else
		print(Meta("title").." Splash now enabled on login.")
	end
	db.splash = not db.splash
end
info.classcolor = function(arg)
	if db.classcolor then
		print(Meta("title").." kgPanel class coloring is now disabled.")
	else
		print(Meta("title").." kgPanel class coloring is now enabled.")
	end
	db.classcolor = not db.classcolor
end
info.help = function() 
	dialog("TUSUI_HELP1")
end
info.help2 = function()
	dialog("TUSUI_HELP2")
end
info.about = function() 
	DEFAULT_CHAT_FRAME:AddMessage(Meta("Title").." v"..Meta("Version").." - Created by: "..Meta("Author")..". Email: "..Meta("X-Email").." for suggestions, comments, or help.")
end
info.install = function()
	Install()
end

function TUSUI_Commands(arg)
	if type(info[arg]) == 'function' then 
		info[arg]()
	else 
		print(Meta("Title")..": Available commands are /tusui 'help', 'help2','classcolor', 'splash', 'install', or 'about'.")
	end
end

SLASH_TUSUI1 = "/tusui";
SlashCmdList["TUSUI"] = TUSUI_Commands